﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Diagnostics;
using System.ComponentModel;
using System.Windows.Forms;


namespace Microsoft.Data.ConnectionUI
{
   public partial class DataConnectionDialog : Form
   {
      private class BasicConnectionProperties : IDataConnectionProperties
      {
         public void Reset()
         {
            _s = String.Empty;
         }

         public void Parse(string s)
         {
            _s = s;
            if (PropertyChanged != null)
            {
               PropertyChanged(this, EventArgs.Empty);
            }
         }

         [Browsable(false)]
         public bool IsExtensible
         {
            get
            {
               return false;
            }
         }

         public void Add(string propertyName) { /* Not needed. */ }

         public bool Contains(string propertyName)
         {
            return (propertyName == "ConnectionString");
         }

         public object this[string propertyName]
         {
            get
            {
               if (propertyName == "ConnectionString")
               {
                  return ConnectionString;
               }
               else
               {
                  return null;
               }
            }
            set
            {
               if (propertyName == "ConnectionString")
               {
                  ConnectionString = value as string;
               }
            }
         }

         public void Remove(string propertyName) { /* Not needed. */}

         public event EventHandler PropertyChanged;

         public void Reset(string propertyName)
         {
            Debug.Assert(propertyName == "ConnectionString");
            _s = String.Empty;
         }

         [Browsable(false)]
         public bool IsComplete
         {
            get
            {
               return true;
            }
         }

         public string ConnectionString
         {
            get
            {
               return ToFullString();
            }
            set
            {
               Parse(value);
            }
         }

         public void Test()
         { }

         public string ToFullString()
         {
            return _s;
         }

         public string ToDisplayString()
         {
            return _s;
         }

         private string _s;
      }
   }
}
