﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Drawing;


namespace Microsoft.Data.ConnectionUI
{
   public partial class DataConnectionDialog : Form
   {
      private class PropertyGridUIControl : UserControl, IDataConnectionUIControl
      {
         public PropertyGridUIControl()
         {
            this.propertyGrid = new DataConnectionAdvancedDialog.SpecializedPropertyGrid();
            this.SuspendLayout();
            // 
            // propertyGrid
            // 
            this.propertyGrid.CommandsVisibleIfAvailable = true;
            this.propertyGrid.Dock = DockStyle.Fill;
            this.propertyGrid.Location = Point.Empty;
            this.propertyGrid.Margin = new Padding(0);
            this.propertyGrid.Name = "propertyGrid";
            this.propertyGrid.TabIndex = 0;
            // 
            // DataConnectionDialog
            // 
            this.Controls.Add(this.propertyGrid);
            this.Name = "PropertyGridUIControl";
            this.ResumeLayout(false);
            this.PerformLayout();
         }

         public void Initialize(IDataConnectionProperties dataConnectionProperties)
         {
            this.connectionProperties = dataConnectionProperties;
         }

         public void LoadProperties()
         {
            this.propertyGrid.SelectedObject = connectionProperties;
         }

         public override Size GetPreferredSize(Size proposedSize)
         {
            return this.propertyGrid.GetPreferredSize(proposedSize);
         }

         private IDataConnectionProperties connectionProperties;
         private DataConnectionAdvancedDialog.SpecializedPropertyGrid propertyGrid;
      }
   }
}
