﻿/*-------------------------------------------------------------------------------------------------------------
** module:			TX Text Control Words
**	file:				DataBaseConnection.cs
** description:	This file contains an adapter class wrapping a DataTable object.
**
** copyright:		© Text Control GmbH, 1991-2013
** author:			T. Kummerow
**-----------------------------------------------------------------------------------------------------------*/
using System.Collections.Generic;
using System.Data;


namespace TX_Text_Control_Words
{
   /// <summary>
   /// Simple adapter class for DataTable objects.
   /// </summary>
   public class DataTableAdapter
   {
      public DataTableAdapter(DataTable table)
      {
         RowCount = 0;
         DataTable = table;
         ColumnNames = new List<string>();

         if (DataTable == null) return;

         RowCount = DataTable.Rows.Count;

         // Get column names
         foreach (DataColumn col in DataTable.Columns) ColumnNames.Add(col.ColumnName);
      }

      /// <summary>
      /// The encapsulated table.
      /// </summary>
      public DataTable DataTable { get; private set; }

      public int RowCount { get; private set; }

      public List<string> ColumnNames { get; private set; }
   } // class DataTableAdapter
}
