﻿/*-------------------------------------------------------------------------------------------------------------
** module:			TX Text Control Words
**	file:				FileHandler.cs
** description:	This file contains the parts of the class handling file operations only used in the ribbon 
**                version of TX Text Control Words.
**
** copyright:		© Text Control GmbH, 1991-2013
** author:			T. Kummerow
**-----------------------------------------------------------------------------------------------------------*/
using System;
using System.Collections.Generic;
using System.Collections.Specialized;
using System.IO;
using System.Security.Cryptography.X509Certificates;
using System.Windows.Forms;
using RibbonLib;


namespace TX_Text_Control_Words
{
   public partial class FileHandler
   {
      public List<RecentItemsPropertySet> RecentFiles { get; set; }

      public void UpdateMenu()
      {
         // Clear recent files list
         RecentFiles.Clear();

         // Check all recent files if they still exist
         CheckFiles();

         // Setup Recent files list
         for (int i = 0; i < _fileList.Count; i++)
         {
            RecentFiles.Add(new RecentItemsPropertySet()
            {
               Label = Path.GetFileName(_fileList[i]),
            });
         }
      }

      public void OpenRecentFile(int index)
      {
         System.Windows.Forms.DialogResult Result;

         if (_bDocumentDirty)
         {
            Result = MessageBox.Show("Save changes to " + DocumentFileName + "?", "Save Changes?", MessageBoxButtons.YesNoCancel, MessageBoxIcon.Question);
            if (Result == DialogResult.Yes)
            {
               FileSave();
            }
         }

         if ((index >= 0) && (index < _fileList.Count))
         {
            DocumentFileName = _fileList[index];
            FileOpen();
         }
      }
   }
}
