﻿/*-------------------------------------------------------------------------------------------------------------
** module:			TX Text Control Words
**	file:				frmHyperlink.cs
** description:	This file contains the dialog which is shown when a hyperlink is created.
**
** copyright:		© Text Control GmbH, 1991-2013
** author:			T. Kummerow
**-----------------------------------------------------------------------------------------------------------*/
using System;
using System.Windows.Forms;


namespace TX_Text_Control_Words
{
   /// <summary>
   /// Is shown when a hyperlink is inserted into a document.
   /// </summary>
   public class FrmHyperlink : Form
   {
      internal Label _lblLinkText;
      internal TextBox _txtLinkTarget;
      internal TXTextControl.TextControl _txHidden;
      internal GroupBox _grpBox01;
      internal RadioButton _optSelFile;
      internal RadioButton _optCurPage;
      internal ListBox _lstTargets;
      internal Label _lblShowTargets;
      internal Label _lblSelectTarget;
      internal Button _btnChooseFile;
      internal Label _lblLinksTarget;
      internal TextBox _txtLinkedText;
      internal Button _btnCancel;
      internal Button _btnOK;
      private string _strLoadedFile;
      /// <summary>
      /// Required designer variable.
      /// </summary>
      private System.ComponentModel.Container _components = null;

      public static DialogResult ShowDialog(TXTextControl.TextControl textControl)
      {
         var frm = new FrmHyperlink { TextControl = textControl };
         return frm.ShowDialog();
      }

      private FrmHyperlink()
      {
         //
         // Required for Windows Form Designer support
         //
         InitializeComponent();
      }

      /// <summary>
      /// Clean up any resources being used.
      /// </summary>
      protected override void Dispose(bool disposing)
      {
         if (disposing)
         {
            if (_components != null)
            {
               _components.Dispose();
            }
         }
         base.Dispose(disposing);
      }

      #region Windows Form Designer generated code
      /// <summary>
      /// Required method for Designer support - do not modify
      /// the contents of this method with the code editor.
      /// </summary>
      private void InitializeComponent()
      {
         System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(FrmHyperlink));
         this._txHidden = new TXTextControl.TextControl();
         this._grpBox01 = new System.Windows.Forms.GroupBox();
         this._optSelFile = new System.Windows.Forms.RadioButton();
         this._optCurPage = new System.Windows.Forms.RadioButton();
         this._lstTargets = new System.Windows.Forms.ListBox();
         this._lblShowTargets = new System.Windows.Forms.Label();
         this._lblSelectTarget = new System.Windows.Forms.Label();
         this._btnChooseFile = new System.Windows.Forms.Button();
         this._txtLinkTarget = new System.Windows.Forms.TextBox();
         this._lblLinksTarget = new System.Windows.Forms.Label();
         this._txtLinkedText = new System.Windows.Forms.TextBox();
         this._lblLinkText = new System.Windows.Forms.Label();
         this._btnCancel = new System.Windows.Forms.Button();
         this._btnOK = new System.Windows.Forms.Button();
         this._grpBox01.SuspendLayout();
         this.SuspendLayout();
         // 
         // _txHidden
         // 
         this._txHidden.Font = new System.Drawing.Font("Arial", 10F);
         this._txHidden.Location = new System.Drawing.Point(8, 240);
         this._txHidden.Name = "_txHidden";
         this._txHidden.PageMargins.Bottom = 79.03D;
         this._txHidden.PageMargins.Left = 79.03D;
         this._txHidden.PageMargins.Right = 79.03D;
         this._txHidden.PageMargins.Top = 79.03D;
         this._txHidden.Size = new System.Drawing.Size(184, 32);
         this._txHidden.TabIndex = 0;
         this._txHidden.TabStop = false;
         this._txHidden.Text = "This Text Control is hidden at run time";
         // 
         // _grpBox01
         // 
         this._grpBox01.Controls.Add(this._optSelFile);
         this._grpBox01.Controls.Add(this._optCurPage);
         this._grpBox01.Controls.Add(this._lstTargets);
         this._grpBox01.Controls.Add(this._lblShowTargets);
         this._grpBox01.Controls.Add(this._lblSelectTarget);
         this._grpBox01.Controls.Add(this._btnChooseFile);
         this._grpBox01.Controls.Add(this._txtLinkTarget);
         this._grpBox01.Controls.Add(this._lblLinksTarget);
         this._grpBox01.Location = new System.Drawing.Point(8, 56);
         this._grpBox01.Name = "_grpBox01";
         this._grpBox01.Size = new System.Drawing.Size(404, 178);
         this._grpBox01.TabIndex = 4;
         this._grpBox01.TabStop = false;
         this._grpBox01.Text = "Link to:";
         // 
         // _optSelFile
         // 
         this._optSelFile.Location = new System.Drawing.Point(280, 125);
         this._optSelFile.Name = "_optSelFile";
         this._optSelFile.Size = new System.Drawing.Size(96, 20);
         this._optSelFile.TabIndex = 5;
         this._optSelFile.Text = "S&elected file";
         this._optSelFile.CheckedChanged += new System.EventHandler(this.optSelFile_CheckedChanged);
         // 
         // _optCurPage
         // 
         this._optCurPage.Checked = true;
         this._optCurPage.Location = new System.Drawing.Point(280, 99);
         this._optCurPage.Name = "_optCurPage";
         this._optCurPage.Size = new System.Drawing.Size(96, 20);
         this._optCurPage.TabIndex = 4;
         this._optCurPage.TabStop = true;
         this._optCurPage.Text = "C&urrent page";
         this._optCurPage.CheckedChanged += new System.EventHandler(this.OptCurPage_CheckedChanged);
         // 
         // _lstTargets
         // 
         this._lstTargets.Location = new System.Drawing.Point(8, 96);
         this._lstTargets.Name = "_lstTargets";
         this._lstTargets.Size = new System.Drawing.Size(244, 56);
         this._lstTargets.TabIndex = 3;
         this._lstTargets.SelectedIndexChanged += new System.EventHandler(this.LstTargets_SelectedIndexChanged);
         // 
         // _lblShowTargets
         // 
         this._lblShowTargets.Location = new System.Drawing.Point(280, 80);
         this._lblShowTargets.Name = "_lblShowTargets";
         this._lblShowTargets.Size = new System.Drawing.Size(88, 16);
         this._lblShowTargets.TabIndex = 4;
         this._lblShowTargets.Text = "Show targets in:";
         // 
         // _lblSelectTarget
         // 
         this._lblSelectTarget.Location = new System.Drawing.Point(8, 80);
         this._lblSelectTarget.Name = "_lblSelectTarget";
         this._lblSelectTarget.Size = new System.Drawing.Size(256, 16);
         this._lblSelectTarget.TabIndex = 3;
         this._lblSelectTarget.Text = "&Select a named target in current page (optional):";
         // 
         // _btnChooseFile
         // 
         this._btnChooseFile.Location = new System.Drawing.Point(310, 15);
         this._btnChooseFile.Name = "_btnChooseFile";
         this._btnChooseFile.Size = new System.Drawing.Size(88, 24);
         this._btnChooseFile.TabIndex = 3;
         this._btnChooseFile.Text = "Choose &file...";
         this._btnChooseFile.Click += new System.EventHandler(this.BtnChooseFile_Click);
         // 
         // _txtLinkTarget
         // 
         this._txtLinkTarget.Location = new System.Drawing.Point(8, 44);
         this._txtLinkTarget.Name = "_txtLinkTarget";
         this._txtLinkTarget.Size = new System.Drawing.Size(390, 20);
         this._txtLinkTarget.TabIndex = 2;
         this._txtLinkTarget.TextChanged += new System.EventHandler(this.RequiredFields_TextChanged);
         // 
         // _lblLinksTarget
         // 
         this._lblLinksTarget.Location = new System.Drawing.Point(8, 24);
         this._lblLinksTarget.Name = "_lblLinksTarget";
         this._lblLinksTarget.Size = new System.Drawing.Size(184, 16);
         this._lblLinksTarget.TabIndex = 7;
         this._lblLinksTarget.Text = "Li&nk to page location or local file:";
         // 
         // _txtLinkedText
         // 
         this._txtLinkedText.Location = new System.Drawing.Point(12, 27);
         this._txtLinkedText.Name = "_txtLinkedText";
         this._txtLinkedText.Size = new System.Drawing.Size(248, 20);
         this._txtLinkedText.TabIndex = 1;
         this._txtLinkedText.TextChanged += new System.EventHandler(this.RequiredFields_TextChanged);
         // 
         // _lblLinkText
         // 
         this._lblLinkText.Location = new System.Drawing.Point(8, 8);
         this._lblLinkText.Name = "_lblLinkText";
         this._lblLinkText.Size = new System.Drawing.Size(144, 16);
         this._lblLinkText.TabIndex = 99;
         this._lblLinkText.Text = "Lin&ked text:";
         // 
         // _btnCancel
         // 
         this._btnCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
         this._btnCancel.Location = new System.Drawing.Point(332, 240);
         this._btnCancel.Name = "_btnCancel";
         this._btnCancel.Size = new System.Drawing.Size(80, 24);
         this._btnCancel.TabIndex = 0;
         this._btnCancel.TabStop = false;
         this._btnCancel.Text = "&Cancel";
         // 
         // _btnOK
         // 
         this._btnOK.Location = new System.Drawing.Point(246, 240);
         this._btnOK.Name = "_btnOK";
         this._btnOK.Size = new System.Drawing.Size(80, 24);
         this._btnOK.TabIndex = 5;
         this._btnOK.Text = "&OK";
         this._btnOK.Click += new System.EventHandler(this.BtnOK_Click);
         // 
         // FrmHyperlink
         // 
         this.AcceptButton = this._btnOK;
         this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
         this.CancelButton = this._btnCancel;
         this.ClientSize = new System.Drawing.Size(424, 272);
         this.Controls.Add(this._txHidden);
         this.Controls.Add(this._grpBox01);
         this.Controls.Add(this._txtLinkedText);
         this.Controls.Add(this._lblLinkText);
         this.Controls.Add(this._btnCancel);
         this.Controls.Add(this._btnOK);
         this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
         this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
         this.MaximizeBox = false;
         this.MinimizeBox = false;
         this.Name = "FrmHyperlink";
         this.ShowInTaskbar = false;
         this.StartPosition = System.Windows.Forms.FormStartPosition.CenterParent;
         this.Text = "Hyperlinks";
         this.Load += new System.EventHandler(this.FrmHyperlink_Load);
         this._grpBox01.ResumeLayout(false);
         this._grpBox01.PerformLayout();
         this.ResumeLayout(false);
         this.PerformLayout();

      }
      #endregion

      public TXTextControl.TextControl TextControl { get; set; }

      private void FillTargetsListbox(TXTextControl.TextControl tx)
      {
         _lstTargets.Items.Clear();

         try
         {
            foreach (TXTextControl.DocumentTarget dt in tx.DocumentTargets)
            {
               _lstTargets.Items.Add(dt.TargetName);
            }
         }
         catch { }
      }

      private int GetTargetID(TXTextControl.TextControl tx, string TargetName)
      {
         foreach (TXTextControl.DocumentTarget dt in tx.DocumentTargets)
         {
            if (dt.TargetName == TargetName) return dt.ID;
         }

         return 0;
      }

      /// <summary>
      /// Apply changes to the selected hyperlink, or insert a new hyperlink.
      /// </summary>
      /// <param name="sender">Sender</param>
      /// <param name="e">Event arguments</param>
      private void BtnOK_Click(object sender, System.EventArgs e)
      {
         TXTextControl.HypertextLink linkCur = null;
         bool bIsExternalLink;

         try
         {
            linkCur = TextControl.HypertextLinks.GetItem();
         }
         catch (Exception ex)
         {
            MessageBox.Show(ex.Message, ProductName, MessageBoxButtons.OK, MessageBoxIcon.Information);
            return;
         }

         // Determine which type of link we have (see lstTargets_SelectedIndexChanged) and remove
         // the '#' character.
         if (_txtLinkTarget.Text.StartsWith("#"))
         {
            bIsExternalLink = false;
            _txtLinkTarget.Text = _txtLinkTarget.Text.Remove(0, 1);
         }
         else bIsExternalLink = true;

         if (linkCur == null)
         {
            // No existing Hypertext link at caret position, insert a new one. 
            if (bIsExternalLink)
            {
               TXTextControl.HypertextLink linkExt 
                  = new TXTextControl.HypertextLink(_txtLinkedText.Text, _txtLinkTarget.Text);
               TextControl.HypertextLinks.Add(linkExt);
            }
            else
            {
               int nTgtID = GetTargetID(TextControl, _txtLinkTarget.Text);
               TXTextControl.DocumentLink linkInt 
                  = new TXTextControl.DocumentLink(_txtLinkedText.Text, TextControl.DocumentTargets.GetItem(nTgtID));
               TextControl.DocumentLinks.Add(linkInt);
            }
         }
         else
         {
            // Update existing Hypertext link
            linkCur.Text = _txtLinkedText.Text;
            linkCur.Target = _txtLinkTarget.Text;
         }

         DialogResult = System.Windows.Forms.DialogResult.OK;
         Close();
      }

      private void OptCurPage_CheckedChanged(object sender, System.EventArgs e)
      {
         if (TextControl != null) FillTargetsListbox(TextControl);
      }

      private void optSelFile_CheckedChanged(object sender, System.EventArgs e)
      {
         FillTargetsListbox(_txHidden);
      }

      private void BtnChooseFile_Click(object sender, System.EventArgs e)
      {
         TXTextControl.LoadSettings ls = new TXTextControl.LoadSettings() { ApplicationFieldFormat = TXTextControl.ApplicationFieldFormat.MSWord };

         _txHidden.Load(TXTextControl.StreamType.All, ls);
         _txtLinkTarget.Text = ls.LoadedFile;
         _strLoadedFile = ls.LoadedFile;
      }

      private void LstTargets_SelectedIndexChanged(object sender, System.EventArgs e)
      {
         _txtLinkTarget.Text = _strLoadedFile + "#" + _lstTargets.SelectedItem;
      }

      /// <summary>
      /// Disable OK button if txtLinkedText or txtLinkTarget are empty
      /// </summary>
      /// <param name="sender">Sender</param>
      /// <param name="e">Event arguments</param>
      private void RequiredFields_TextChanged(object sender, System.EventArgs e)
      {
         _btnOK.Enabled = (_txtLinkedText.Text != "" && _txtLinkTarget.Text != "");
      }

      /// <summary>
      /// If the caret is inside an existing hyperlink, copy the hyperlink's text and link
      /// information to the text boxes on the form.
      /// </summary>
      /// <param name="sender">Sender</param>
      /// <param name="e">Event arguments</param>
      private void FrmHyperlink_Load(object sender, System.EventArgs e)
      {
         TXTextControl.HypertextLink linkExt = null;
         TXTextControl.DocumentLink linkInt = null;

         try
         {
            linkExt = TextControl.HypertextLinks.GetItem();
            linkInt = TextControl.DocumentLinks.GetItem();
         }
         catch { }

         if (linkExt != null)
         {
            _txtLinkedText.Text = linkExt.Text;
            _txtLinkTarget.Text = linkExt.Target;
            _optCurPage.Enabled = false;
            _optSelFile.Checked = true;
         }
         else if (linkInt != null)
         {
            _txtLinkedText.Text = linkInt.Text;
            _txtLinkTarget.Text = linkInt.DocumentTarget.TargetName;
            _optCurPage.Checked = true;
            _optSelFile.Enabled = false;
         }

         _btnOK.Enabled = (_txtLinkedText.Text != "" && _txtLinkTarget.Text != "");
         FillTargetsListbox(TextControl);
         _txHidden.Left = Width; // hide it
         _strLoadedFile = "";
      }
   }
}
