﻿/*-------------------------------------------------------------------------------------------------------------
** module:			TX Text Control Words
**	file:				FrmMaxRowsPreview.cs
**
** copyright:		© Text Control GmbH, 1991-2013
** author:			T. Kummerow
**-----------------------------------------------------------------------------------------------------------*/
using System;
using System.Windows.Forms;

namespace TX_Text_Control_Words
{
   /// <summary>
   /// A small dialog containing a spinner control to let the user select the
   /// maximum number of data rows to show in a mail merge preview.
   /// </summary>
   public partial class FrmMaxRowsPreview : Form
   {
      private FrmMaxRowsPreview()
      {
         InitializeComponent();
      }

      /// <summary>
      /// Shows the dialog and returns the selected number.
      /// </summary>
      /// <returns>The number of rows to show or 0 if Cancel button was pressed.</returns>
      public static new int Show()
      {
         var frm = new FrmMaxRowsPreview();
         if (frm.ShowDialog() == DialogResult.OK) return (int) frm._spinnerMax.Value;

         return 0;
      }

      private void BtnOK_Click(object sender, EventArgs e)
      {
         DialogResult = System.Windows.Forms.DialogResult.OK;
         Close();
      }

      private void _btnCancel_Click(object sender, EventArgs e)
      {

      }
   }
}
